/*******************************************************************************
 $Author: dmc $
 $Revision: 3083 $
 $Date: 2022-07-08 12:15:34 -0300 (Fri, 08 Jul 2022) $
 $HeadURL: http://support2.silvermountaintargets.com/svn/smt/smtv2-lodi/public/javascripts/viewer_toolbar_military.js $
*******************************************************************************/

var toolbar_military = new function() {

    this.init = function() {
        this.icon = $("<img src='images/crosshair_acog.png' class='toolbar_icon'"
        + " style='border-radius:30px;'>");
    }

    // whether icon should be shown on main toolbar
    this.ready = function() {
        this.set_defaultValues(); // if/as necessary...
		return this.is_mil() && (admin_check() || ro_check()); // only ADMIN or RO
    }

    // try to open this panel (return false to cancel)
    this.show = function() {
        return true;
    }

    // try to close this panel (return false to cancel)
    this.hide = function() {
        return true;
    }

    this.is_mil = function () {
		return g_config.is_mil ? true : false;
    }

    this.stringname_RangeOfficer = function () {
        return toolbar_military.is_mil() ? "Range Staff" : "Range Officer";
    }

    this.stringname_RangeOfficers = function () {
        return toolbar_military.is_mil() ? "Range Staff" : "Range Officers";
    }

    this.stringname_Shooter = function (shooternum,shooter_count) {
        //     draw_chooseShooterScorer
		var str = toolbar_military.is_mil() ? "Firer" : "Shooter";
		var i = shooternum == undefined ? 0 : shooternum;

		// multi shooters:
		if (shooter_count == 2) str = ((i == 0) ? ("Left " + str) : ("Right " + str));
		else if (shooter_count == 3) str = ((i == 0) ? ("Left " + str) : ((i == 1) ? ("Middle " + str) : ("Right " + str)));
		return str;
    }

    this.stringname_Scorer = function () {
        //     draw_chooseShooterScorer
        return toolbar_military.is_mil() ? "Coach" : "Scorekeeper";
    }

	this.ZeroAdjustClicksizes = [
		{name: "0.1 Mil", size: mil_to_moa(0.1)}
		, {name: "1/4 MOA", size:1/4}
		, {name: "1/8 MOA", size:1/8}
	];

	this.BallisticTruing = [
		{name: "Vert-ES"}
		, {name: "Hor-ES"}
		, {name: "VMR"}
		, {name: "Velo-Mean"}
		, {name: "Velo-ES"}
		, {name: "Velo-StdDev"}
		, {name: "Velo-StdErr"}
		, {name: "NATO D90"}
	];

    // display the panel in the supplied div
    this.draw = function(div) {
        var frame_id = cur_string().frame().id();
        // zero adjust the scope
        if ("object" != typeof cur_string().frame().data.config) {
        	var frame_config = { config: {zero_adjust: 0, wind_adjust:0}}; // default to false
        	cur_string().frame().data.config = frame_config;
        	frame_id_crud(frame_id,frame_config);
        }
        var cf_config = cur_string().frame().data.config; // current frame config data

        var item = toolbar.new_button(div, "Zero Adjust", function() {
            var newval = !cf_config.zero_adjust;
            frame_id_crud(frame_id,{ config: { zero_adjust: newval } });
            if (newval) {
                frame_id_crud(frame_id,{ config: { CQB: false, LSWzero: false, RMRzero: false, BUISzero: false } });
				config_crud({ sighter_count: 0, sighter_convertible: false, shots_mode: 5 });
            }
        }, cf_config.zero_adjust);
        var item = toolbar.new_button(div, "Wind Adjust", function() {
            var newval = !cf_config.wind_adjust;
            frame_id_crud(frame_id,{ config: { wind_adjust: newval } });
            if (newval) {
                frame_id_crud(frame_id,{ config: { CQB: false, LSWzero: false, RMRzero: false, BUISzero: false } });
				config_crud({ sighter_count: 0, sighter_convertible: false, shots_mode: 5 });
            }
        }, cf_config.wind_adjust);

		var LR_ETS = true; // klugey for now...
		LR_ETS = false;
		if (1|| LR_ETS) {
			// choosable click size for "Zero Adjust", default is 0.1 mil
			//
			var any_value_set = false;
			$.each(this.ZeroAdjustClicksizes, function (idx,clicksize_item) {
				if (cf_config.Zero_clicksize == clicksize_item.name) {
					any_value_set = true;
				}
				var item = toolbar.new_button(div, clicksize_item.name, function() {
				    frame_id_crud(frame_id,{ config: { Zero_clicksize: clicksize_item.name } });
				}, cf_config.Zero_clicksize == clicksize_item.name);
			});
			if (!any_value_set) {
		        frame_id_crud(frame_id,{ config: { Zero_clicksize: "0.1 Mil" } });
			}

		    if (0 && cur_string().face().data.distances) { // DMC 8 July 2022 turn this back on once we support choosable distances
				div.append("<br>Range");
				$.each(cur_string().face().data.distances, function (idx,distance_item) { // [...       { "d": 1000 * YARDSTOMETRES, "name": "1000y", "unit": "y", "p": "true" }, ...]
					var item = toolbar.new_button(div, distance_item.name, function() {
						frame_id_crud(frame_id,{ config: { chosen_distance: distance_item } });
					}, cf_config.chosen_distance &&  cf_config.chosen_distance.name == distance_item.name);
				});
		    }


		}
		div.append("<hr>");
		if (1 || !LR_ETS) { // ! LR_ETS
		    var item = toolbar.new_button(div, "RMR Zero", function() {
		        var newval = !cf_config.RMRzero;
		        frame_id_crud(cur_string().frame().id(),{ config: { RMRzero: newval } });
		        if (newval) {
		            frame_id_crud(cur_string().frame().id(),{ config: { zero_adjust: false, CQB: false, LSWzero: false, BUISzero: false } });
					config_crud({ sighter_count: 0, sighter_convertible: false, shots_mode: 3 });
		        }
		    }, cf_config.RMRzero);
		    
		    var item = toolbar.new_button(div, "BUIS Zero", function() {
		        var newval = !cf_config.BUISzero;
		        frame_id_crud(cur_string().frame().id(),{ config: { BUISzero: newval } });
		        if (newval) {
		            frame_id_crud(cur_string().frame().id(),{ config: { zero_adjust: false, CQB: false, LSWzero: false, RMRzero: false  } });
					config_crud({ sighter_count: 0, sighter_convertible: false, shots_mode: 5 });
		        }
		    }, cf_config.BUISzero);

		    var item = toolbar.new_button(div, "LSW Zero", function() {
		        var newval = !cf_config.LSWzero;
		        frame_id_crud(cur_string().frame().id(),{ config: { LSWzero: newval } });
		        if (newval) {
		            frame_id_crud(cur_string().frame().id(),{ config: { zero_adjust: false, CQB: false, RMRzero: false, BUISzero: false } });
					config_crud({ sighter_count: 0, sighter_convertible: false, shots_mode: 10 });
		        }
		    }, cf_config.LSWzero);
		    
		    var item = toolbar.new_button(div, "CQB", function() {
		        var newval = !cf_config.CQB;
		        frame_id_crud(cur_string().frame().id(),{ config: { CQB: newval } });
		        if (newval) {
		            frame_id_crud(cur_string().frame().id(),{ config: { zero_adjust: false, LSWzero: false, RMRzero: false } });
		        }
		    }, cf_config.CQB);
		} // ! LR_ETS

        // toolbar_string.draw_chooseShooterScorer(div);

        // div.append("<hr>");
        // toolbar.new_text(div, "Add/remove/edit users:");
        // toolbar_system.drawUsersEditor(div);

        div.append("<hr>");
        toolbar_match.draw_chooseCourseOfFire(div);

		if (1 || LR_ETS) {
	        div.append("<hr>");
			//
			if ('object' != typeof cf_config.BallisticTruing) {
				cf_config.BallisticTruing = {}
			    frame_id_crud(frame_id,{ config: { BallisticTruing: cf_config.BallisticTruing } });
			}
			
		    var item = toolbar.new_button(div, "Ballistic Truing", function() {
		        var newval = !cf_config.BallisticTruing.enabled;
		        frame_id_crud(cur_string().frame().id(),{ config: { BallisticTruing: {enabled: newval } } });
		    }, cf_config.BallisticTruing.enabled);
		    if (cf_config.BallisticTruing.enabled) {
				$.each(this.BallisticTruing, function (idx,clicksize_item) {
					if (cf_config.Zero_clicksize == clicksize_item.name) {
						any_value_set = true;
					}
					var item = toolbar.new_button(div, clicksize_item.name, function() {
						var bt = {}; bt[clicksize_item.name] = !cf_config.BallisticTruing[clicksize_item.name]
						frame_id_crud(frame_id, { config: { BallisticTruing: bt } });
					}, cf_config.BallisticTruing[clicksize_item.name]);
				});
			}
		}

        div.append("<hr>");

        // div.append("<hr>");
        // toolbar_string.draw_chooseTargetFaces(div);
        // toolbar_string.draw_chooseGrid(div);
    }

    this.set_defaultValues = function () {
        if (!this.is_mil()) return;
        if (g_config.basic_mode) config_crud({ basic_mode: false }); // defined course of fire
        if (!g_config.use_role_shooter) config_crud({ use_role_shooter: true });
        if (!g_config.use_role_scorer) config_crud({ use_role_scorer: true });
        if (g_config.shot_display_delay != 0) config_crud({ shot_display_delay: 0 });
        if (g_config.option_access_mode != 0) config_crud({ option_access_mode: 0 }); // Everyone manage strings
        if (g_config.event_enabled) config_crud({ event_enabled: false });
        // one shooter per target
        for (var i in g_strings) {
            var str = g_strings[i];
            if (str.frame().data.enabled && str.frame().string().id() == str.id()) {
                if (str.data.shooter_count != 1) {
                    str.crud({ shooter_count: 1 });
                    g_socket.emit("update_string_stats", i);
                }
                if (str.frame().data.string_params && str.frame().data.string_params.shooter_count != 1){
                    str.frame().crud({ string_params: { shooter_count: 1 } });
                }
            }
        }

    }



}

var toolbar_military_tgt = new function() {

    this.init = function() {
        this.icon = $("<img src='images/mil-tgt.png' class='toolbar_icon'"
        + " style='border-radius:30px;width=auto;height=auto;'>");
    }

    // whether icon should be shown on main toolbar
    this.ready = function() {
		return toolbar_military.is_mil() && (admin_check() || ro_check()); // only ADMIN or RO
    }

    // try to open this panel (return false to cancel)
    this.show = function() {
        return true;
    }

    // try to close this panel (return false to cancel)
    this.hide = function() {
        return true;
    }

    // display the panel in the supplied div
    this.draw = function(div) {

        // div.append("<hr>");
        // toolbar_match.draw_chooseCourseOfFire(div);

        div.append("<hr>");
        toolbar_string.draw_chooseTargetFaces(div);
        toolbar_string.draw_chooseGrid(div);
    }

}
